"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var methods_generator_1 = require("./methods.generator");
var utilities_1 = require("../utilities");
exports.queryBuilder = function (_a) {
    var isScalar = _a.isScalar, field = _a.field, type = _a.type, renderedFragmentInner = _a.renderedFragmentInner;
    var _b = methods_generator_1.createMethodsArgs(field), GQLArgs = _b.GQLArgs, GQLVariables = _b.GQLVariables;
    var hasArgs = field.args.length > 0;
    var methodName = field.name;
    var typeNameLower = type;
    if (isScalar) {
        return "sgtsQL`\n      " + typeNameLower + " " + methodName + " " + (hasArgs ? "(" + GQLVariables.join(',') + ")" : '') + " {\n        " + methodName + (hasArgs ? "(" + GQLArgs.join(',') + ")" : '') + "\n      }`";
    }
    else {
        return "sgtsQL`\n      " + typeNameLower + " " + methodName + " " + (hasArgs ? "(" + GQLVariables.join(',') + ")" : '') + " {\n        " + methodName + (hasArgs ? "(" + GQLArgs.join(',') + ")" : '') + " {\n          " + renderedFragmentInner + "\n        }\n      } ${isFragment? fragment: ''}\n      `";
    }
};
exports.createQueryFunction = function (_a) {
    var field = _a.field, type = _a.type, renderedFragmentInner = _a.renderedFragmentInner;
    var isScalar = utilities_1.evaluateType(field).isScalar;
    var Query = exports.queryBuilder({ field: field, isScalar: isScalar, renderedFragmentInner: renderedFragmentInner, type: type });
    if (isScalar) {
        return "export const " + field.name + "GQLNode = (): DocumentNode =>  {\n      return " + Query + ";\n    }";
    }
    else {
        return "export const " + field.name + "GQLNode = (fragment: string | DocumentNode): DocumentNode => {\n      const { isString, isFragment, fragmentName } = guessFragmentType(fragment);\n      return " + Query + ";\n    }";
    }
};
