"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = __importDefault(require("path"));
var chalk_1 = __importDefault(require("chalk"));
var fs_1 = __importDefault(require("fs"));
var inquirer_1 = __importDefault(require("inquirer"));
var figlet_1 = __importDefault(require("figlet"));
var templates_1 = require("../templates");
require('dotenv').config();
function getConfigParams(env) {
    require('custom-env').env(env);
    var configPath = path_1.default.resolve(process.cwd(), '.sgtsrc.js');
    if (fs_1.default.existsSync(configPath))
        return require(path_1.default.resolve(process.cwd(), '.sgtsrc.js'));
    return null;
}
exports.getConfigParams = getConfigParams;
exports.createConfig = function () { return __awaiter(void 0, void 0, void 0, function () {
    var sourceType, sourceValue, outputPath, codeGen, configPath, replace, codeGenDisplay, configValue, e_1;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 8, , 9]);
                console.log(chalk_1.default.magenta(figlet_1.default.textSync('SGTS', {
                    horizontalLayout: 'full',
                })));
                return [4, inquirer_1.default.prompt([
                        {
                            type: 'list',
                            name: 'type',
                            message: 'Where does your GraphQL schema comes from?',
                            choices: [
                                {
                                    name: 'From an http endpoint',
                                    value: 'endpoint',
                                },
                                {
                                    name: 'From a JSON file',
                                    value: 'json',
                                },
                            ],
                        },
                    ])];
            case 1:
                sourceType = _a.sent();
                return [4, inquirer_1.default.prompt([
                        {
                            type: 'input',
                            name: 'source',
                            message: sourceType.type === 'endpoint'
                                ? "What's the url of your GraphQL api endpoint?"
                                : "What's the absolute path to your GraphQL JSON schema?",
                        },
                    ])];
            case 2:
                sourceValue = _a.sent();
                return [4, inquirer_1.default.prompt([
                        {
                            type: 'input',
                            name: 'ouput',
                            message: 'Where do you want to save your generated file?',
                            default: './__generated.ts',
                        },
                    ])];
            case 3:
                outputPath = _a.sent();
                return [4, inquirer_1.default.prompt([
                        {
                            type: 'checkbox',
                            name: 'codeGens',
                            message: 'What do you want to generate?',
                            choices: [
                                new inquirer_1.default.Separator('------'),
                                {
                                    name: 'Typescript definitions',
                                    checked: true,
                                    disabled: 'Sgts will always generate definitions by default',
                                },
                                new inquirer_1.default.Separator('------'),
                                {
                                    name: 'Vanilla es6 helpers functions',
                                    value: 'codegenMethods',
                                },
                                {
                                    name: 'Apollo React Hooks',
                                    value: 'codegenReactHooks',
                                },
                                {
                                    name: 'Vue Apollo Hooks',
                                    value: 'codegenVueHooks',
                                },
                                {
                                    name: 'Only GraphQL string templates',
                                    value: 'codegenTemplates',
                                },
                            ],
                        },
                    ])];
            case 4:
                codeGen = _a.sent();
                configPath = path_1.default.resolve(process.cwd(), '.sgtsrc.js');
                if (!fs_1.default.existsSync(configPath)) return [3, 6];
                return [4, inquirer_1.default.prompt([
                        {
                            type: 'confirm',
                            name: 'delete',
                            message: 'A config file already exists in this folder, do you want to replace it?',
                        },
                    ])];
            case 5:
                replace = _a.sent();
                if (!replace.delete) {
                    console.log('Ok bye!');
                    return [2];
                }
                _a.label = 6;
            case 6:
                codeGenDisplay = codeGen.codeGens.map(function (m) { return m + ": true,"; });
                configValue = "module.exports = {\n  " + sourceType.type + ": \"" + sourceValue.source + "\",\n  output: \"" + outputPath.ouput + "\",\n  " + codeGenDisplay.join('\n  ') + "\n}\n    ";
                return [4, fs_1.default.writeFileSync(configPath, templates_1.configTemplate(configValue))];
            case 7:
                _a.sent();
                console.log(chalk_1.default.green("Configuration file created at " + chalk_1.default.bold(configPath)));
                return [3, 9];
            case 8:
                e_1 = _a.sent();
                return [2, Promise.reject(e_1)];
            case 9: return [2];
        }
    });
}); };
