"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var generate_1 = require("./generate");
var chalk_1 = __importDefault(require("chalk"));
var utilities_1 = require("./utilities");
var save_1 = require("./save");
function sgtsGenerate(_a) {
    var endpoint = _a.endpoint, json = _a.json, output = _a.output, customScalars = _a.customScalars, header = _a.header, prefix = _a.prefix, suffix = _a.suffix, jsMode = _a.jsMode, codegenMethods = _a.codegenMethods, codegenReactHooks = _a.codegenReactHooks, codegenVueHooks = _a.codegenVueHooks, codegenTemplates = _a.codegenTemplates, download = _a.download;
    return __awaiter(this, void 0, void 0, function () {
        var schema, generatedString, e_1;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _b.trys.push([0, 6, , 7]);
                    console.log("\n Sgts v" + require('../package.json').version);
                    return [4, utilities_1.fetchSchemas({ endpoint: endpoint, header: header, json: json, download: download })];
                case 1:
                    schema = _b.sent();
                    if (!schema) return [3, 4];
                    return [4, generate_1.generate(schema, prefix, suffix, customScalars, codegenMethods, codegenReactHooks, codegenVueHooks, codegenTemplates)];
                case 2:
                    generatedString = _b.sent();
                    return [4, save_1.saveFile(generatedString, output, jsMode)];
                case 3: return [2, _b.sent()];
                case 4:
                    console.warn(chalk_1.default.yellow('\n ⚠️ You need to either provite a source url or a path to your json schema file'));
                    _b.label = 5;
                case 5: return [3, 7];
                case 6:
                    e_1 = _b.sent();
                    console.error(chalk_1.default.red(e_1));
                    return [2, Promise.reject(e_1)];
                case 7: return [2];
            }
        });
    });
}
exports.sgtsGenerate = sgtsGenerate;
