#!/usr/bin/env node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var commander_1 = __importDefault(require("commander"));
var runtime_1 = require("./runtime");
var chalk_1 = __importDefault(require("chalk"));
var rc_1 = require("./rc");
var runSgtsCLI = function () {
    commander_1.default
        .version(require('../package.json').version)
        .option('generate [generate]', "Generate using config file '.sgtsrc.js'")
        .option('init', 'Init your config file')
        .option('-e, --endpoint <endpoint>', 'GraphQl Api endpoint')
        .option('-j, --json <json>', 'Json file of your GraphQL Api schema')
        .option('-o, --output <output>', 'Output path of your generated file')
        .option('--codegen-methods', 'Generate all your graphQL methods fully typed (Inspired by Prisma)')
        .option('--codegen-react-hooks', 'Generate useMutation and useQuery React hooks typed')
        .option('--codegen-vue-hooks', 'Generate useMutation and useQuery React hooks typed')
        .option('--codegen-templates', 'Add gql query strings to the generated output')
        .option('--header <header>', 'Additional header option to fetch your schema from endpoint')
        .option('--customScalars <scalars>', 'Provide your custum scalars in format {"myScalar": "MyType"...}')
        .option('-p, --prefix <prefix>', 'Add prefix to all your types (ex: User becomes IUser with --suffix I)')
        .option('-s, --suffix <suffix>', 'Add suffix to all your types (ex: User becomes UserModel with --suffix Model)')
        .option('--compileToJs', 'Generate the methods in Js with declaration files instead of Ts')
        .option('-D, --download <download>', 'Specify the path to download the GraphQL introspection schema')
        .parse(process.argv);
    var generate = commander_1.default.generate, endpoint = commander_1.default.endpoint, json = commander_1.default.json, _a = commander_1.default.output, output = _a === void 0 ? './__generated.ts' : _a, customScalars = commander_1.default.customScalars, header = commander_1.default.header, prefix = commander_1.default.prefix, suffix = commander_1.default.suffix, codegenMethods = commander_1.default.codegenMethods, jsMode = commander_1.default.jsMode, codegenReactHooks = commander_1.default.codegenReactHooks, codegenVueHooks = commander_1.default.codegenVueHooks, codegenTemplates = commander_1.default.codegenTemplates, download = commander_1.default.download, init = commander_1.default.init;
    if (generate) {
        var env = typeof generate === 'boolean' ? 'development' : generate;
        var config = rc_1.getConfigParams(env);
        if (config)
            generateUsingConfig(config);
        else
            rc_1.createConfig();
    }
    else if (init) {
        rc_1.createConfig();
    }
    else {
        if (customScalars) {
            try {
                customScalars = JSON.parse(customScalars);
            }
            catch (e) {
                console.error(chalk_1.default.red('Invalid custom scalars format, expected {"myScalar": "MyType" ...}'));
                return;
            }
        }
        generateUsingConfig({
            endpoint: endpoint,
            json: json,
            output: output,
            customScalars: customScalars,
            header: header,
            prefix: prefix,
            suffix: suffix,
            codegenMethods: codegenMethods,
            jsMode: jsMode,
            codegenReactHooks: codegenReactHooks,
            codegenVueHooks: codegenVueHooks,
            codegenTemplates: codegenTemplates,
            download: download,
        });
    }
};
var generateUsingConfig = function (config) { return __awaiter(void 0, void 0, void 0, function () {
    var e_1;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 2, , 3]);
                return [4, runtime_1.sgtsGenerate(config)];
            case 1:
                _a.sent();
                return [3, 3];
            case 2:
                e_1 = _a.sent();
                console.error(chalk_1.default.red('💔 Generation failed'));
                return [3, 3];
            case 3: return [2];
        }
    });
}); };
runSgtsCLI();
